


                                       Preface


     The Version Control & Maintenance System is an application that allows
     either the client or the programmer to maintain their database of
     source code.  VCM is written in a dBASE IV compatible language called
     Foxpro.

     As a client, this system allows you to obtain the latest updated
     source code.  As a programmer, this system allows you to maintain
     another programmer's database of source code.  At the same time, other
     programmers can keep up with your modifications.  All without the need
     to "check-out" program files.

     For the VCM System to work, you must have a copy of PKWare's
     PKZIP/PKUNZIP utilities.  If you're not connected to both host and
     remote sites, you also need a PC-to-PC communication application.  I
     recommend at least a 9600 baud modem and a communication program such
     as PC Anywhere.

     An IBM personal computer (80386 or better) is recommended.  For
     improved performance, it is highly recommended that the user obtain at
     least three megabytes of extended memory.  A color monitor and a mouse
     are also recommended.

     Considerable effort was expended to make the user reference manual as
     complete as possible.  However, this documentation is in no way to be
     considered an instructive guide to MS-DOS, Foxpro, or PC-to-PC
     communications.  Many reference texts are available on the market that
     explain the MS-DOS operating system, Foxpro programming, and PC-to-PC
     communications.  If you need more information, your reference
     materials should include one of these texts.

     My advice is to read the contents of this user manual.  Familiarize
     yourself with its information.  If you have any questions concerning
     this application, feel free to write or call.




















                                     - Page 1 -


                             Copyright/License/Warranty


     This document and the program Version Control & Maintenance ("the
     software") are copyrighted by the author.  The copyright owner hereby
     licenses you to use the software given these restrictions:

          o  the program shall be supplied in its original, unmodified
             form, which includes this documentation;

          o  for-profit use without a license is prohibited;

          o  the program may not be included - or bundled - with other
             goods or services.  Exceptions may be granted upon written
             request only.

          o  no fee is charged beyond a reasonable amount for the media
             and handling ($10 maximum suggested);

          There is no warranty of any kind.  The copyright owner may not
          be held liable for any damages, including any lost profits or
          other incidental or consequential damages arising out of or
          inability to use the software.  By using the software, you agree
          to this.

          Copyright (C) 1992-2002 Dennis Allen.  All rights reserved.  All
          trademarks mentioned herein belong to their respective owners.





























                                     - Page 2 -


                                  TABLE OF CONTENTS


     Preface.............................................................1
     Copyright/License/Warranty..........................................2
     Introduction........................................................5
      Manual Content ....................................................5
      Upgrading from Previous Version ...................................6
      Notation Convention ...............................................7
     System Startup......................................................8
      Client Overview ...................................................8
      Programmer Overview ...............................................8
      Host Start-up .....................................................9
      Creating REMOTE.ZIP ..............................................10
      Remote Start-up ..................................................10
      Updating VCM Paths ...............................................11
       Updating a VCM Path Record ......................................14
      Creating HOST.ZIP ................................................16
      Maintaining VCM records ..........................................17
      ZIP Files ........................................................17
      Quit .............................................................19
     Printing VCM Files.................................................20
      Printing VCM Edit List ...........................................21
      Printing VCM History Edit List ...................................21
      Printing VCM Path List ...........................................22
      Check Translated Code ............................................23
      Check Parameter Code .............................................23
      Compare VCM to Remote ............................................24
      Compare VCM to Backup ............................................25
      Check DIF files ..................................................25
      Quit .............................................................25
     System Setup.......................................................26
      Expression Builder ...............................................27
      Printer Control Codes ............................................28
      Change Color Set .................................................31
       Customizing Color Sets ..........................................32
       Color Schemes ...................................................32
       Color Pairs .....................................................36
         Character Code Color ..........................................36
         Character Code Example ........................................37
         RGB Color .....................................................38
         RGB Example ...................................................38
         Color Pair List ...............................................39
      Problems & Suggestions ...........................................39
      All About... .....................................................40
      Edit File Lists ..................................................40
       Included File List ..............................................40
       Excluded File List ..............................................40
         Version Control ...............................................40
      Display/Print Manual .............................................41
      Quit .............................................................41
     Utilities..........................................................42
      Create new VCM Path File set .....................................43
      Create new VCM File set ..........................................43
      Rollback VCM file set ............................................43
      Create new DIF Files, host to remote .............................43
                                     - Page 3 -


                                  TABLE OF CONTENTS


      Create new DIF Files, host to backup .............................44
      Rebuilding Indices ...............................................44
      Initializing Databases ...........................................44
      Purging Backup.$$$ files .........................................45
     Quit to DOS........................................................46
     Appendices.........................................................47
      Appendix A/ Generic Editor .......................................47
      Appendix A-1/ Foxpro System Menu .................................54
       Sysmenu edit ....................................................54
       Foxpro Calculator ...............................................54
       Foxpro Calendar .................................................55
       Foxpro DOS Shell ................................................55
       Print Setup .....................................................55
       Print Mode ......................................................55
       Printer Eject ...................................................55
       User Manual .....................................................56
       Configuration Manual ............................................56
       Video Mode ......................................................56
      Appendix B/ Backup/Restore Data Files ............................57
      Appendix C/ Error Handling .......................................58
       Verification ....................................................58
         Bad Record Count ..............................................58
         Invalid/missing memo file .....................................59
         Visual Foxpro DBF File ........................................59
       Disk Space ......................................................60
       Printer not Ready ...............................................60
       Multi-User Errors ...............................................61
       Syntax Error ....................................................61
     Glossary...........................................................62
     Index..............................................................65























                                     - Page 4 -


                                    Introduction


     The Version Control & Maintenance System is an application that allows
     either the client or the programmer to maintain their database of
     source code.  VCM is written in a dBASE IV compatible language called
     Foxpro.

     Before continuing, we should explain a couple of terms.  First, we
     will refer to the Version Control & Maintenance System as the VCM
     System.  Or simply as VCM.

     When we refer to a user's database of source code, we're talking about
     program files.  Every application has it's own set of program files,
     also known as source code.  A user's entire collection of
     applications, maintained by the VCM System, is a database of source
     code.

     When we refer to an "editor", it is a program module that allows us to
     add, delete, or change database records. The word "edit" means to
     update, maintain, or change a database record.

     When we refer to a "window", it is a section of the screen that is
     receiving output.  Windows may overlap each other on the screen.  They
     are characterized by a double line border and usually have some sort
     of title.

     A "record filter" determines the access allowed to a database.  Only
     those records, defined by a record filter, may be viewed, edited, or
     printed.  Record filters are created/selected using an "expression
     builder".

     A "file directory" is also known as a "file path".  They refer to the
     file structure on a hard drive.

     Finally, when we say "DOS", we refer to the disk operating system.
     It's usually MS-DOS, but could be Microsoft windows, UNIX, or even the
     Macintosh OS.

     The first section of this manual will describe how to install the VCM
     System.  There are sections that explain the edit, print, system, and
     utility menus.  Appendices are included to describe the generic
     operations of editors, error handling, optimizing VCM, and
     establishing a backup procedure.












                                     - Page 5 -


                                    Introduction


                        Upgrading from Previous Version


     In the previous version of VCM, I attempted to introduce multi-user
     capability.  I added a user file and User ID fields.  But I wasn't
     satisfied with either security or performance.  So the current version
     of VCM no longer has user id fields.  VCM is once again a single user
     application.

     If you are upgrading your copy of VCM, and have used multiple users,
     run option [1] of the utility menu to create a brand new VCM master
     set.  To track multiple users, create multiple user resource
     directories.  In turn, each user resource directory would need to
     specify a different data directory.  See the configuration manual for
     details.

     Oh, the current version of VCM can now handle wildcarding on both the
     included and the excluded file lists.  Version control is now
     specified in the excluded file list.  I suggest, therefore, you delete
     the file called VCMSYS.MEM from your user resource directory and use
     the system menu to create new file lists.

     Finally, the REMOTE.ZIP and HOST.ZIP files will now be created in (and
     received from) the data directory.  You can no longer specify a
     separate directory.  So before you use your PC-to-PC communication,
     remember where your data directory is located.  Or else modify your
     batch files to copy the ZIP files in and out of the data directory.


























                                     - Page 6 -


                                    Introduction


                              Notation Conventions


     CAPITAL LETTERS
          Capital letters indicates a command.  During command entry, this
          text should be entered exactly as it appears.  Unless specified,
          any command may be in upper or lower-case letters.

     lower case
          Parameters to commands are usually typed in lower-case
          characters.

     Ellipsis "..."
          The ellipsis represent repetition of a previous item.

     Single Key "[ ]"
          The single key command is represented by the characters "[" "]".

     Control keys
          Control keys are designated with a "[Ctrl]-" followed by the name
          of another key (for example: [Ctrl]-[S]).  To enter a control
          key, press [Ctrl] on your keyboard and, while holding it down,
          press the additional key.  On some Foxpro menus, control keys are
          designated with a "^" followed by the name of another key (for
          example: ^[End] for [Ctrl]-[End]).

     Carriage Return
          Depending on your keyboard, the same key may be represented by
          different descriptions.  For example, the carriage return may be
          represented as [Enter], [Return], or [Bent arrow symbol].

     Alternate key
          On an IBM PC keyboard, alternate keys are designated with a
          "[Alt]-" followed by the name of another key (for example: [Alt]-
          [V]).  To enter an alternate key, press [Alt] on your keyboard
          and, while holding it down, press the additional key.

          On a Macintosh keyboard, [Alt] is produced by holding down both
          the [Ctrl] key and the [Option] key.  To produce [Alt]-[V], for
          example, you must press [Ctrl], [Option], and [V] at same time.

          On a Unix keyboard, [Alt] cannot be used.  But most [Alt]
          combinations will have alternate keystrokes.  For more on Unix
          keystroke equivalents, see the file called READFPU.TXT.

          Unix note:  This application normally defines [F10] to complete
          user input.  Unix, however, uses [Ctrl]-[W] to complete user
          input.  [F10] is used instead of [Alt] to activate the Foxpro
          system menu (see Appendix A-1).




                                     - Page 7 -


                                   System Startup



     For version control to proceed, two copies of the VCM System is
     usually installed.  One on a remote machine, one on a host machine.
     The host machine will contain the master copy of source code.  You
     would own the remote machine.  Normal operation would proceed as
     follows:


                                Client Overview


     From the remote machine, you would use PC-to-PC software to log onto
     the host machine.  You would run the host machine's VCM System and
     generate a file called REMOTE.ZIP.  This file will contain all source
     code, updated since the last time you logged onto the host machine.

     After exiting the host's VCM System, you would send REMOTE.ZIP to your
     remote machine.  Then you would log off the host machine.  Back on the
     remote machine, you would run the VCM System and retrieve REMOTE.ZIP.
     This process ensures you have to latest source code and can be
     repeated as often as desired.

     Note:  As a client, if you modify source code, be aware that any
     updates from the host will eliminate your changes.  Retrieving ZIP
     files, however, does create backup copies of source code.


                              Programmer Overview


     If your a programmer, and have the security clearance, you may also
     send your latest updates to the host machine.  On the remote machine,
     you would run the VCM System and generate a file called HOST.ZIP.
     This file will contain all source code, updated since the last time
     you ran the remote machine's VCM System.

     After exiting your VCM System, you would log into the host machine.
     You would send HOST.ZIP to the host.  Then, you would run the host
     machine's VCM System and retrieve HOST.ZIP.  This process can be
     repeated as often as desired.


     Note:  As a programmer, be aware that any updates from the host will
     override your changes.  Retrieving ZIP files, however, does create
     backup copies of source code.  It is the programmer's responsibility,
     therefore, to:  Receive the host's changes, reconcile the remote's
     changes, and return the updated source code to the host.






                                     - Page 8 -


                                   System Startup


                                 Host Start-up


     For normal operations, each VCM System must first be initialized.  But
     purposes of this session, however, the host system and the remote
     system will be on the same machine.

     Your computer should be running and you should be at the DOS prompt
     (in your startup directory).  You should have already installed your
     VCM System and your Foxpro runtime unit.

     For start-up operations to begin, the system administrator on the host
     machine would create the VCM master set.  However, since this is the
     VERY first time you will be running this application (and only for
     purposes of testing), you will begin as if you were a system
     administrator on a host machine.  At the DOS prompt, type:


          FOX VCM


     and press [Enter].  All VCM database files are verified (see Appendix
     C).  Since you have no data, you will be prompted for a root
     directory.  For our example, select `C:\VCM'.  This directory, and all
     sub-directories, will be assigned to your master set.  You should then
     see is the following startup screen:



                  Version Control & Maintenance, Version 04.00.00
                    (c) 1992 Dennis Allen, All rights reserved
     -----------------------  M A I N    M E N U -----------------------

                         1 - Retrieve HOST.ZIP File
                         2 - Create REMOTE.ZIP File
                         E - Create/Maintain Edit Files
                         P - Print Reports
                         S - System Setup (Query)
                         U - Utilities
                         C - Change Status (Host)
                         Q - Quit this program


                               Make a selection:



     This is our main menu.  Option '1' deals with HOST.ZIP.  On a remote
     machine, you may create HOST.ZIP.  On a host machine, option '1'
     retrieves HOST.ZIP (if it exists in the data directory).



                                     - Page 9 -


                                   System Startup


     Option '2' deals with REMOTE.ZIP.  On a host machine, you may create
     REMOTE.ZIP.  On a remote machine, option '2' will retrieve REMOTE.ZIP
     (if it exists in the data directory).

     Option 'E' allows you to create and maintain all Edit files.  Option
     'P' will print reports. Option 'S' allows you to change printer codes
     and system defaults.  Option 'U' contain miscellaneous options that
     allow the user to maintain VCM.  Option 'Q' will return you to the DOS
     prompt.

     Option 'C' will let you toggle between remote and host modes.  It is
     available only to the system administrator.  Please refer to the
     configuration manual for more information.

     There are a couple of ways to select an option.  One way is to simply
     press the highlighted key, (example: press [S] for system setup).
     Another way is to press the up and down cursor keys to highlight the
     desired option.  Then, by pressing [Enter], the highlighted option is
     selected.

     Note:  If you have a mouse, you can move the mouse cursor to the
     desired option.  Pressing the left mouse button will then select the
     option.


                              Creating REMOTE.ZIP


     The next step is to create REMOTE.ZIP.  At the main menu, press [2].
     There will be a wait window.  Press any key to create REMOTE.ZIP (or
     [Esc] to abort).

     Since remote paths have not been defined, you will be prompted whether
     to send source code.  Press [Y] for the default of yes.  Our
     REMOTE.ZIP file will be created in the data directory (see system
     menu, all about... for data directory location).


                                Remote Start-up


     At this point, we would exit VCM and use our PC-to-PC package to send
     REMOTE.ZIP (from the data directory) to the remote machine and logoff.
     We would then run VCM on the remote machine.  But for our session,
     assume we did that already.  Since we are still a temporary system
     administrator, press [C] at the main menu.  You should now be a remote
     machine.  Press [2] to retrieve the REMOTE.ZIP file.

     This is the first time we're using the remote system.  So we will get
     an error message "Missing VCM Paths.  Please update and try again.".
     Don't panic.


                                     - Page 10 -


                                   System Startup


     The VCM System has only three database files:  VCMPATH.DBF, VCM.DBF,
     and VCMHIST.DBF. VCMPATH.DBF stores all file paths.  VCM.DBF stores
     all file path, names, dates, and times.  VCMHIST.DBF simply stores a
     history of changes to VCM.DBF.

     VCMPATH.DBF not only contains the host's list of file directories, but
     the remote's corresponding list of directories.  In other words, the
     host can have a "C:\VCM" system that updates the remote's "C:\VCM"
     system.

     We got an error message because we haven't yet defined the remote's
     corresponding directories.  So at the main menu, press [E].  You
     should see the following screen:



                  Version Control & Maintenance, Version 04.00.00
                    (c) 1992 Dennis Allen, All rights reserved
     ----------------------  E D I T    M E N U ------------------------

                        1 - Edit VCM File
                        2 - Edit VCM History File
                        3 - Edit VCM Path File

                        Q - Return to main menu


                                 Your selection:



     This is the edit menu.  Here, all components of the VCM System can be
     maintained.  Option '1' will allow you to maintain VCM.DBF.  Option
     '2' will allow you to maintain VCMHIST.DBF.  Option '3' will allow you
     to maintain VCMPATH.DBF.  Option 'Q' will return you to the main menu.

     Before continuing, notice that the edit window is slightly smaller
     than the main menu window.  This is a built-in feature.  This feature
     allows the user to see how far he/she is into the program.  It is
     intended to give the user a sense of depth.


                               Updating VCM Paths


     Updating VCM Path records is simple.  At the edit menu, press [3].
     The following screen will appear:






                                     - Page 11 -


                                   System Startup



                  Version Control & Maintenance, Version 04.00.00
                    (c) 1992 Dennis Allen, All rights reserved
     -------------------------- VCM Path File -------------------------

          File Path       : C:\VCM\

          Remote File Path:  :\VCM\


            Toggle Index (File Path)    Toggle Order (Ascending)
            Add    Browse Delete Find   Goto   Help  Recall  Update  Quit



     This screen is typical of a generic editor used with Foxpro.  At the
     bottom of the screen are all the one-character options available to
     the user.

     Like the main menu, there are three ways of selecting a function.  By
     direct keystroke, by the cursor keys and [Enter], or by the mouse.
     Before continuing, we will briefly describe each function.

                                  Add Function

     Pressing [A] will allow you to add a record to the current database.
     The cursor will be positioned on the first field in the record.
     Whether adding or updating a record, there only a few keystrokes you
     need to know.

     You can move the cursor from field to field using the arrow keys.  For
     instance, the Right arrow, the Down arrow, and the Enter key, moves
     the cursor forward one field at a time.  The up arrow moves the cursor
     back one field.

     Note:  If you have a mouse, you also can move from field to field.
     Simply move the mouse cursor to the desired field and press the left
     mouse button.

     The [Home] key will move the cursor to the beginning of a field.  If
     it is already there, [Home] will move the cursor to the first field in
     the screen.  [End] will move the cursor to the end of the field.  If
     it is already there, [End] will move the cursor to the last field in
     the screen.

     If you need more information on any field, press [F1].  If there is
     help information, a help window will be displayed.  The help window
     will remain until you press either [Esc] or [F10].

     Note:  If you have a mouse, move the mouse cursor to the desired
     field.  Press the right mouse button, once to move to the field, and
     once for the help text.

                                     - Page 12 -


                                   System Startup


     After you have entered your data, moving the cursor beyond the last
     input field on the screen tells the editor to accept the record.  You
     can either use the arrow keys to move the cursor, or press [F10].
     [Esc] will abort any updating, returning the screen to its original
     condition.

                                Browse Function

     Pressing [B] will invoke the Foxpro browse function.  The browse
     function will display as many database records as will fit on one
     screen.  You use the arrow keys to move from record to record.
     Pressing [F10] will return you to the edit screen.  The browse
     function is explained in more detail in Appendix A.

                                Delete Function

     Pressing [D] will allow you to delete the currently displayed record.
     You will be prompted whether you are sure.  Pressing [Y] deletes the
     record from the database.

                                 Find Function

     Pressing [F] will invoke the find function.  This option is a quick
     way of finding a desired record.  Since the current database is
     indexed by file path, this option will prompt you for the host's file
     path.  Type the desired path and press [Enter].  If found, the desired
     record will be displayed.  You could then delete it, or update it.

                                 Goto Function

     Pressing [G] will create a pop-up menu.  This popup menu allows the
     user to display different records in the current database.  Press [F]
     for the first record in the database.  Press [L] for the last record.
     Press [N] for the next record.  Press [P] for the previous record.
     The goto window remains active until you press [Esc] or [Q] to quit.
     The goto function is explained in more detail in Appendix A.

                                 Help Function

     Pressing [H] will display a summary of commands used in the edit menu.
     Pressing any key after that returns you to the edit menu.

                                Recall Function

     When available, pressing [R] allows you to recall a deleted record.
     You will be presented with a browse window of all deleted records.
     Simply locate the record to be recalled and press [Enter].

     To enable this feature, see your configuration manual.




                                     - Page 13 -


                                   System Startup


                             Toggle Index Function

     For a database with multiple indices, the toggle option will be
     displayed.  The toggle option allows the user to change what index
     will be used with the [F]ind option.  The current index is displayed
     in parenthesis.

     For example, if the current index is by host file path, pressing [T]
     will change the current index to the remote's file path.  Upon
     pressing [F], the user will be prompted for the remote's file path.
     Pressing [T], repeatedly, will eventually return you to the host's
     file path.

                             Toggle Order Function

     This option toggles the order of the current index.  The current order
     is displayed in parenthesis.

     For example, if the current order is ascending, pressing [O] will
     toggle the order to descending.  If the current index is by last name,
     then 'ALPHA' will come after 'BETA'.  Pressing [O] again will change
     the current index back to ascending.

                                Update Function

     Pressing [U] allows you to update the currently displayed record.
     Like the add function, pressing [F10] will complete the update.
     Pressing [Esc] will abort the update.

                                 Quit Function

     Finally, pressing [Q] would return you the menu that invoked the
     editor.  For more information on the capabilities of this type of
     editor, see Appendix A.


                           Updating a VCM Path Record


     Now that you have an idea how the editor works, you can update the
     current record.  Press [U] at the option prompt.

     The "file path" field is the host's file path and can only be edited
     on the host. The next field specifies the remote's file path,
     corresponding to the host file path.  For our session, update all
     records.  Replace ` :\VCM' in the remote path with `C:\TMP' and press
     [Enter].






                                     - Page 14 -


                                   System Startup


     Since `C:\TMP' does not exist, you will be prompted whether to create
     the directory.  Press [Y] for yes.  The current record should be
     complete.  Use the [G]oto function to check for any other records.
     Change any ` :\VCM\' reference to `C:\TMP\'.  When finished, press [Q]
     to quit.  From the edit menu, press [Q] to quit to the main menu.  Now
     that we have completed the directory information, press [2] at the
     main menu to receive REMOTE.ZIP.  This time, the process of receiving
     should be without error.  The directory `C:\TMP' should be a mirror
     image of `C:\VCM'.

     Note:  If you still get a "PATH not found", go back to the VCM Path
     editor and check your records.  All remote paths MUST be defined.









































                                     - Page 15 -


                                   System Startup



                               Creating HOST.ZIP


     Normally, the next step is to send a HOST.ZIP to the host.  You would
     press [1] to create a HOST.ZIP (in the data directory).  At that
     point, you would log off the remote and use our PC-to-PC package to
     log onto the host machine and send the HOST.ZIP, then log on to the
     host machine and retrieve the HOST.ZIP.

     But we have a situation where both the host and remote are on the same
     machine.  So when we retrieved our REMOTE.ZIP, both host and remote
     systems were updated.

     Well, we've installed the source code database for our host and remote
     machines.  If you wish, experiment sending and receiving ZIP files.
     Or you may want to stay at the main menu for the next section in this
     manual.  We will be going over the VCM file editors.



































                                     - Page 16 -


                               Maintaining VCM records


     From the main menu, press [E] for the edit menu.  You should see the
     following:



                  Version Control & Maintenance, Version 04.00.00
                    (c) 1992 Dennis Allen, All rights reserved
     ----------------------  E D I T    M E N U ------------------------

                        1 - Edit VCM File
                        2 - Edit VCM History File
                        3 - Edit VCM Path File

                        Q - Return to main menu


                                 Your selection:



     This is the edit menu.  Here, all components of the VCM System can be
     maintained.

     The VCM System has only three database files:  VCMPATH.DBF, VCM.DBF,
     and VCMHIST.DBF.  VCMPATH.DBF stores file paths assignments.  VCM.DBF
     stores all file path, names, dates, and times.  VCMHIST.DBF simply
     stores a history of changes to VCM.DBF.

     Option '1' will allow you to maintain VCM.DBF.  Option '2' will allow
     you to maintain VCMHIST.DBF.  Option '3' will allow you to maintain
     VCMPATH.DBF.  Option 'Q' will return you to the main menu.


                                   ZIP Files


     When you create either REMOTE.ZIP or a HOST.ZIP, the VCM System
     searches through all the directories in VCMPATH.DBF.  All files found
     are listed in VCM.DBF.  Any file additions, deletions, or updates to
     VCM.DBF are logged into VCMHIST.DBF.  When you send/receive a ZIP
     file, a copy of VCM.DBF, VCMHIST.DBF, and VCMPATH.DBF are included.

     We have already looked at the VCMPATH.DBF file editor.  Now let's take
     a look at the VCM.DBF editor.  At the edit menu, press [1].  You
     should see the following screen:








                                     - Page 17 -


                               Maintaining VCM records



                  Version Control & Maintenance, Version 04.00.00
                    (c) 1992 Dennis Allen, All rights reserved
     ------------------------ Edit VCM File ---------------------------
          File Path       : C:\VCM\
          Remote File Path: C:\TMP\

          File Name       : VCM.PRG                    Actual Host
          Date: 07/16/96                                07/16/96
          Time: 16:19:06                                16:19:06
          Size:      44696 bytes                        44696 bytes

          Type: H

            Modify Host File   Display Backup File    Display DIF File
            Toggle Index (File Path)    Toggle Order (Ascending)
            Add    Browse Delete Find   Goto   Help  Update   Quit



     The edit functions are exactly the same as in the VCM Path editor.
     There are additional functions, allowing a system administrator to
     actually modify the current file.  As well as the ability to view
     associated files.

     You have the "file path" field, which comes from the host.  The
     "remote file path" field comes from the associated host "file path" in
     VCMPATH.DBF.  The "file path", and "file name" determine a unique
     record.  The "date", "time", and "size" fields determine if a file has
     been changed.  To the right of these fields are displayed the file's
     actual date, time, and size.

     The record "type" field indicates what action took place, the last
     time you created or received a ZIP.  The possible values are:


          F    -    File.  No action.
          D    -    Deleted.  File was removed from other VCM System.
          H    -    History.  File that has been updated.
          O    -    Out of Sync.  File is overwritten from host.
          U    -    Undefined.  File cannot be unzipped.


     If a file record is type "F" or "H", no problem.  Type "F" indicates
     nothing has occurred with this file, lately.  Type "H" indicates that
     the file has been updated, but not on both VCM Systems.

     If a file record is type "D", the file was deleted from the other VCM
     System.  If you are on the remote, the file was deleted on host.
     While receiving a ZIP from the host, you would be prompted whether you
     wish to physically remove your copy.


                                     - Page 18 -


                               Maintaining VCM records


     If a file record is type "O", you received a file from host.  If a
     file record is type "U", the file could not be unzipped on other
     machine (usually the host).  Let me explain.

     The VCM System allows you to modify a file on the remote AND host at
     the same time.  Nothing prevents that.  However, the HOST machine has
     priority.

     Example:  Say that you and the host modify the same file, since the
     last time you were on the host.  If you try to send this file to the
     host, you will get a file type "U" and the file will not be unzipped.
     When you receive a ZIP from the host, your file will be overwritten
     with the host's file (file type "O").

     From the VCM editor, pressing [M] allows you to edit the actual file.
     It's location defined by the current path, depending with whether you
     are in host or remote mode.

     When the VCM System transfer files between host and remote, it creates
     backup files.  These files will have a "$" file extension.  From the
     VCM editor, you may press [c] to view this backup file.  Again, it's
     location defined by the current path, depending with whether you are
     in host or remote mode.

     Note:  If you ever receive an out-of-sync file, simply use the backup
     copy to add your changes to the host's file.  Then send a new HOST.ZIP
     to the host.

     In the VCM utility menu, option 4 allows you to run file compares.
     Either between host and remote, or between actual files and backup
     files.  The resulting DIF file can be viewed by pressing [I] at the
     VCM editor.  See utility menu for more details.

     Well, that's the VCM.DBF file layout.  The edit functions are exactly
     the same as in the VCM Path editor.  The VCMHIST.DBF file layout is
     exactly the same.  Experiment, if you wish, in adding, updating, or
     browsing.  When finished, press [Q] to quit to the edit menu.

     Just remember:  Unless explicitly stated, a "file path" refers to the
     host's file path.


                                      Quit


     Well, that's all you need to know about the edit menu.  Later, you can
     experiment with finding, deleting, and updating records.  For now,
     simply press [Q] to return to the main menu.





                                     - Page 19 -


                                   Print VCM Files


     In the first half of this manual we learned how to create the VCM
     database.  Now we are going to learn how to print record in the VCM
     system.

     From the previous examples, you should now be at the main menu.  We
     will be printing a record, so make sure your printer is connected and
     on-line.  If not, you may wish to skip this section.  If your printer
     is ready, press [P].  You should see the following screen:



                  Version Control & Maintenance, Version 04.00.00
                    (c) 1992 Dennis Allen, All rights reserved

     ------------------------- P R I N T    M E N U --------------------

          1 - Print VCM         Edit List    A - Check Translated Code
          2 - Print VCM History Edit List    B - Check Parameter  Code
          3 - Print VCM Path    Edit List    C - Compare VCM to Remote
                                             D - Compare VCM to Backup
                                             E _ Check DIF files

                         Q - Return to main menu



                                 Your selection:



     The menu is simple and self-explanatory.  Option '1' allows you to
     print an edit list of VCM.DBF.  Option '2' will print an edit list of
     VCMHIST.DBF.  Option '3' will print an edit list of VCMPATH.DBF.

     Option 'A' allows you to verify translated files against your version
     control files.  Option 'B' will show you which files have been updated
     recently.  Option 'C' allows you to compare host and remote files.
     Option `D' will compare host (or remote) files to backup files.
     Option `E' will run a listing of files generated from options `4' or
     `5' of the utility menu.  Option 'Q' will return you to the main menu.

     Note:  Options 'A' & 'B' assume VCM.DBF is current.  Options `C' & `D'
     will prompt you to create a new VCM.DBF file (option 2 of the utility
     menu).









                                     - Page 20 -


                                   Print VCM Files


                             Printing VCM Edit List


     Option '1' produces an edit list of VCM.DBF.  Option '2' produces an
     edit list of VCMHIST.DBF.  Since each report provides the same prompts
     and produces the same type of output, we will skip describing the
     option '1' report.


                         Printing VCM History Edit List


     Option '2', of the print menu, introduces the concept of the option
     grid.  The VCM History edit list will be your most often used report.
     This report will tell you what events occurred when a ZIP was sent or
     received.  At the print menu, press [2].

     You will be prompted whether to ignore records that match actual
     files.  That is, print only records that differ with the actual files
     (date, time, or size) will be listed.  The location of actual files,
     depending on whether you are in host or remote mode.  Press [N].  You
     should see the following screen:


                  Version Control & Maintenance, Version 04.00.00
                  (c) 1992 Dennis Allen, All rights reserved

     ------------------- Print VCM History File ------------------------

               File Path       :

               File Name       :

               Date:   /  /
               Time:   :  :
               Size:

               Type:

               Index File :
               Index Order:

                Print   Screen    Help   Update    Quit



     You are given an option grid.  The option grid will look like the VCM
     edit window.  The option grid prompts will determine what records will
     be printed and in what order.  For example, specifying "H" for type
     will print a listing of all files that were extracted from the last
     ZIP.


                                     - Page 21 -


                                   Print VCM Files


     Most fields provide this wild-carding technique.  The exception is the
     date field.  An file date of "01/01/1991", for example, will print
     only those files have been updated since January 1, 1991.

     From this option grid, you are also allowed to select the index file
     and index order.  These fields are the push button equivalent to the
     toggle index/toggle order found in the VCM history editor.

     Press [F10] to complete the option grid.  You will be given a menu of
     choices, depending on the report.  You can press [U] to update the
     option grid.  You can press [H] for help, or press [Q] to quit to the
     print menu.

     Pressing [S] for screen mode, or [P] for print mode, will start
     creating a print file.  During this operation, you can abort by
     pressing [Esc].

     If you pressed [S], you will see the report displayed upon the screen.
     Press [Pgup] or [Pgdn] to view the report.  Press [Esc] or [F10] to
     return to the option grid.

     Note:  To find out how many records are in the report, perform a
     screen display first.  Then use the mouse to grab the displayed window
     and drag it up.  The count should be at the bottom of the previous
     window.

     Pressing [P] will copy the report to the printer.  When you are
     finished, press [Q] to return to the print menu.

     Note:  If you need to adjust the printer device or printer controls,
     use option S of the main menu.  See System setup.


                          Printing VCM Path Edit List


     Option '3' of the print menu will offer an option grid, similar to the
     VCM Path editor.  Like the previous two reports, press [F10] completes
     the option grid.  From there, you can press [S] to view the report,
     [P] to print the report, or [Q] to quit and return to the print menu.













                                     - Page 22 -


                                   Print VCM Files


                             Check Translated Code


     Upon pressing [A], at the print menu, you will be given the VCM Path
     option grid.  Press [F10] to complete the grid.  Press [C] to
     continue.

     All version control files (see system setup) are check against
     translated files.  The first comment line, beginning with "*" and
     containing "Version" will be compared.  A report will be displayed,
     listing only files with comment lines that do not match.  You can then
     determine if your translated code is up-to-date with your version
     control code.

     Use [PgUp] or [PgDn] to scroll through this report.  Press [Alt]-[P]
     to print this report.  Press [Esc] to return to the print menu.


                              Check Parameter Code


     Upon pressing [B], at the print menu, , you will be given the VCM Path
     option grid.  Press [F10] to complete it.  Press [C] to continue.

     All version control files (see system setup) are checked.  You will be
     prompted for the parameter file name and the parameter date.  A report
     will be displayed.  In this report, the first comment line, beginning
     with "*", containing the specified parameter name, and a date greater
     than or equal to the parameter date, will be displayed.  You can then
     determine which files you recently worked on.

     Use [PgUp] or [PgDn] to scroll through this report.  Press [Alt]-[P]
     to print this report.  Press [Esc] to return to the print menu.




















                                     - Page 23 -


                                   Print VCM Files


                             Compare VCM to Remote


     On my computer, I often have modified code of a popular accounting
     system.  I use dVERSION to maintain the modifications.  I also keep a
     copy of the original unmodified source code.  Periodically, I receive
     updates to the original source code.  Updates which must be brought
     over to the modified system.

     This report will help you accomplish this task.  First, you need to
     set up your original master set as "host".  Then, define all your
     remote file paths to your modified master set.  Since both host and
     remote systems are on the same computer, you do not need to create or
     retrieve "ZIP" files.

     Now as a "host", select option "C" of the report menu.  You will be
     prompted whether to update the VCM.DBF file (option 2 of the utility
     menu).  Normally, you press "Y".  You should now see the following
     screen:


                  Version Control & Maintenance, Version 04.00.00
                  (c) 1992 Dennis Allen, All rights reserved

     ------------------- Compare Host to Remote ------------------------

               File Path       :

               File Name       :

               Date:   /  /
               Time:   :  :
               Size:

               Type:

               Index File :
               Index Order:

                Print   Screen    Help   Update    Quit



     Like the option grid in the VCM edit list, this grid allows you to
     select records in VCM.DBF.  The "file path" refers to the host file
     path.  Press [S] to view the report, [P] to print it.  When you are
     finished, press [Q] to quit and return to the print menu.






                                     - Page 24 -


                                   Print VCM Files


                             Compare VCM to Backup


     Instead of comparing host files to remote files, you can compare the
     current host (or remote) files listed in VCM.DBF, to the corresponding
     backup files.  Backup files are the same as seen when trying to
     synchronize host and remote sites.  For example, the backup file of
     JOBPRA.PRG would be JOBPRA.PR$.

     This report will help you accomplish this task.  Option "D" gives the
     same prompts as the previous option "C" of the print menu.


                                Check DIF files


     Options `4' & `5' of the utility menu allows you to perform file
     comparison.  These utility options will generate DIF files.  This
     report will simply let you print a listing of these generated DIF
     files.

     At the print menu, press `E'.  You will be prompted for the minimum
     DIF file size to check.  Any DIF file less then this size will be
     ignored.

     You will then be prompted for the first record number to print, and
     the number of records to print.  Specifying 0 and 0 will just give you
     a DIF file listing.  No contents.  Specifying 1 and 5 means you want
     the first 5 records of each DIF file printed in the report.

     As in other reports, you are then given an option grid.  Press [F10]
     to complete the grid.  Then press [S] to display the report, or [P] to
     print it.  Press [Q] to return to the print menu.


                                      Quit


     Try out the different reports.  When you have experimented enough,
     press [Q] at the print menu to return to the main menu.













                                     - Page 25 -


                                    System Setup


     Option 'S' of the main menu offers several facilities.  Among them,
     the ability to change printer control codes.  Upon pressing [S] at the
     main menu, you should see the following:



                  Version Control & Maintenance, Version 04.00.00
                     (c) 1992 Dennis Allen, All rights reserved

     -------------------  S Y S T E M   S E T U P  ---------------------

                         1 - Edit Expression Builder
                         2 - Edit Printer Control Codes
                         3 - Change Color Set
                         4 - Problems & Suggestions
                         5 - All about...
                         6 - Edit File Lists
                         7 _ Edit Master Password

                         M - Display/Print Manual

                         Q - Quit this Menu


                                Your selection:



     Option '1' will invoke the expression builder.  The expression builder
     creates a record filter.  A record filter defines those records that
     can be viewed, edited, and printed.

     Option '2' allows you to change printer control codes.

     Option '3' will allow you to change the current color set.  If you
     don't like the colors used by VCM, this option lets you change them.

     Option '4' will allow you to leave a message to the application
     author.  Messages can point out a problem or can offer a suggestion.

     Option '5' will display status information about this application.
     What version of Foxpro is running and about much memory is available.

     Option '6' allows you to define the default file list.  That is, the
     list of all files to be included and excluded from the host to remote
     transfer.

     Option '7' allows you to change master password.  That is, the
     password that allows the user to enter this application.

     Option 'M' allows you to display and/or print the user manual.  Option
     'Q' returns you to the main menu.

                                     - Page 26 -


                                    System Setup


                               Expression Builder


     The expression builder allows you to select a record filter from a
     list of record filters.  A record filter defines those records in a
     database that can be viewed, edited, or printed.  The record filter is
     in effect only while your application is running.  Filters can be
     redefined as often as desired.

     At the system setup menu, press [1].  Upon entry, you are given a list
     of existing record filters.  Chose an existing filter.  For example,
     move the cursor to the filter named "History".  Press [Enter].  The
     filter "History" is now active and will allow you to view only VCM.DBF
     and VCMHIST.DBF records with type "H".

     You also might want to create a record filter.  At the system setup
     menu, press [1].  Press [F10] for the menu and press "N" to create an
     expression.  Enter "Deleted" for the name of your expression.  You
     will be given a choice of the custom expression builder, or the Foxpro
     expression builder.  Unless you know how to use the Foxpro expression
     builder, select the custom builder.

     You will be given a popup list of available field names.  Select the
     field "Type".  The next popup will display the action that can be
     taken on "Type".  Select the popup "Contains".  Now you will be
     prompted for a character string.  Type "D" and press [Enter].

     The record filter is displayed.  You may add, delete, or edit phrases
     in the expression.  But just press [F10] to accept the current one.

     That's all there is to it!  You've created a filter that views only
     records of deleted files.  Press [Enter] to select the filter.  You
     will be returned to the system setup menu.  If you don't want to use
     this filter, simply return to the expression builder and press [Esc]
     to abort.

     Note:  If you are running on a network, the user resource directory
     might be shared.  If that is the case, you can still select record
     filters, but only the system administrator can create and maintain
     them.  For more information, refer to the configuration manual.













                                     - Page 27 -


                                    System Setup


                             Printer Control Codes


     At the setup menu, press [2].  The following screen will be displayed:



                  Version Control & Maintenance, Version 04.00.00
                    (c) 1992 Dennis Allen, All rights reserved

     --------------------- S Y S T E M   S E T U P ---------------------

         Printer Name         : Default
         Printer Device       : PRN
         Printer Default      : CHR(27)+"@"
         Printer 10 cpi       :
         Printer 12 cpi       :
         Printer Condense On  :
         Printer Bold      On :
         Printer Bold      Off:
         Printer Underline On :
         Printer Underline Off:
         Printer Font         :

         Number of Straight Lines/Page:         Print in Draft mode?
         Number of Sideways Lines/Page:      Print Number of Copies?


             Press [ESC] to abort and return to main menu...



                                  Printer Name

     The printer name simply identifies the current configuration.  If the
     printer code database is available (see configuration manual), you may
     press [F2] to select from it's list of printers.  Press [F10] to
     complete the screen, press [Esc] to abort any changes.  You may also
     press [Alt]-[P] to print a test report using the current settings (see
     test report, later in this section).

     Note: Upon pressing [F10], you might see the message "Resource files
     are read-only. Cannot save settings".  If you are running on a
     network, the user resource directory is probably shared.  If this is
     the case, only the system administrator can create and maintain
     printer control codes.  You can still change printer control codes,
     but just cannot save them permanently.  For more information, refer to
     the configuration manual.





                                     - Page 28 -


                                    System Setup


                                 Printer Device

     The printer device defines where output is to be sent.  Typically, you
     would use LPT1 or LPT2.  In the Multi-user environment, this option
     also allows you to define the network spooler.  It is suggested,
     however, you let the network handle the spooling and stick with LPT?.

     A new feature has been recently added.  With the printer device, you
     may now use an " ADDITIVE" clause.  For files, this will append output
     to an existing file.  For print devices, this clause might reduce
     paper waste on constantly opening and closing the print spooler.

     In Visual Foxpro, an even better feature has been added.  You can now
     specify any printer defined in your windows print folder.  Example:

     Printer Device:  [NAME "HP Laserjet 5L"]

     You may press [F3] for the list of available printers.  If you specify
     a print device of [DEFAULT], you will get the default printer.
     Finally, if you specify [NAME GETPRINTER()], you will be prompted for
     the desired printer, every time you send output to the printer.

                                 Printer Codes

     If you have an 80 column printer, define the control codes required by
     your printer to invoke compressed printing.  These control codes are
     sometimes referred to as 16.7 or 17 characters per inch.  Also define
     the control codes required to cancel condensed printing.  These
     control codes are sometimes referred to as the print default.  This
     application will use condensed codes in 132 column reports.  Printer
     control codes are specified with xBASE expressions such as:

     CHR(27) + CHR(64)

     or:


     CHR(27) + '@'

     In general, most printer manuals give printer control strings as BASIC
     programming statements using the BASIC function CHR$().  Use the xBASE
     function CHR() instead.

     Note:  If you press [F2], you will see a browse popup of available
     printers.  Simply select your printer and press [Enter].  All printer
     codes will be converted to the selected printer.







                                     - Page 29 -


                                    System Setup


                                  Printer Font

     If you use non-draft mode, output is sent to the print spooler.  This
     prompt (windows only) can control the print spooler's font, pitch, and
     style used.  For example: ["courier new",9 style "B"] sets the font to
     courier new in 9 pitch, bold.  Press [F3] to select from a list of
     available fonts.

     Note:  This is a new feature, based on an undocumented Foxpro command.
     Might not work in all cases.  Depending on the version of Visual
     Foxpro, the font style might be ignored.

                            Straight lines per page

     Most reports is this application are hard-coded.  No form feeds.  So
     to create space between pages, this application needs to know the
     total number of lines per page.  Dot matrix printers use 66 lines.
     Laser printers usually need 60 lines, though some may need 57 lines.

                            Sideways lines per page

     Sometimes a report will need to be printed sideways.  That is,
     landscape instead of portrait. So this application needs to know the
     number of lines to print sideways (landscape).  For a dot matrix
     printer, try 52 lines. For laser printers, try 57 lines.

     In the past, a wide column report would be coded to invoke a DOS
     utility called sideways (for setup, see configuration manual).  While
     still available, today most option grid reports can use the Windows
     print spooler.

     Before you run an option grid report, invoke the Foxpro system menu's
     print setup (see Appendix A-1).  From this dialog box, change the
     orientation from portrait and landscape.  When created, the report
     will then use the number of sideway lines per page.  When printed, the
     report will print via the print spooler (non-draft mode).

                                   Draft mode

     An option grid report creates a report file.  From the option grid,
     there are two ways to print this file:  Draft mode and non-draft mode.
     In draft mode, the report file is copied directly to the print device.
     Under MS-DOS Windows, draft mode bypasses the print spooler.  In non-
     draft mode, the report file is copied to the print device via the
     print spooler.

                                Number of Copies

     Using this option, you can print up to 999 copies of your report.  In
     either draft or non-draft mode.  The default is one.  If you specify a
     negative number, then you will be prompted for the number of copies to
     print at the actual time of printing.

                                     - Page 30 -


                                    System Setup


                                  Test Report

     The ability to print in either draft or non-draft mode is very
     powerful.  With non-draft mode, for example, you can control the print
     spooler's font and font pitch.  Sideway (landscape) output is also
     controlled by the print spooler.  But many print spoolers cannot
     translate printer control codes correctly.

     To test your printer settings, you can print a two page test report by
     pressing [Alt]-[P].  You will be prompted whether to print sideways.
     You will also be prompted whether to print printer codes (to test
     whether the report works with and without them).

     Your two page test report should print using the current print device,
     printer control codes (if specified), number of straight (or sideway)
     lines, and draft mode.  If you're printing sideways and landscape mode
     was not set, you will be prompted with the printer dialog box.  Change
     to landscape mode and the sideways test report should then print via
     the print spooler.

     Adjust the number of straight (or sideway) lines per page until the
     column header on page two line up with the column header on page one.
     If you find out that your sideways (landscape) report does not print
     printer codes, set them to empty or double quotes ("").

     Note:  If you need printer codes for normal (portrait) reports, but
     can't use them for sideways (landscape) reports, you may have to
     create a second application startup icon.  One with a different user
     resource directory (see configuration manual).  Then you can have one
     icon for normal (portrait) reports, and one icon for sideways
     (landscape) reports.


                                Change Color Set


     A Foxpro color set defines all color attributes used by this
     application.  Upon pressing [3] at the system setup, a popup menu will
     display all the different color sets available.  These color sets
     reside within the Foxpro resource file (FOXUSER.DBF).  Use the cursor
     keys to highlight the desired color set.  Then, select by pressing
     [Enter].

     Note: Upon pressing [F10], you might see the message "Resource files
     are read-only. Cannot save settings".  If you are running on a
     network, the user resource directory is probably shared.  If this is
     the case, only the system administrator can permanently select or
     customize a color set.  For more information, refer to the
     configuration manual.




                                     - Page 31 -


                                    System Setup


                             Customizing Color Sets


     A new feature has been added to the color selector.  You can now
     customize colors.  Once a color set has been selected, the color
     selector will search a second Foxpro resource file (FOXUSER2.DBF).  In
     this file, color sets are stored in ASCII text format.  If your color
     set is found in this second file, you will be prompted whether to edit
     the ASCII text of your color set.

     Now the ASCII text layout is simple.  Twelve lines for the twelve
     color schemes of a color set.  Each line containing ten color pairs.


                                 Color Schemes

     Line 1    User Defined Window (Scheme 1)
     Line 2    User Defined Menus  (Scheme 2)
     Line 3    Menu Bar            (Scheme 3)
     Line 4    Menu Popups         (Scheme 4)
     Line 5    Dialogs             (Scheme 5)
     Line 6    Dialog Popups       (Scheme 6)
     Line 7    Alert               (Scheme 7)
     Line 8    Window              (Scheme 8)
     Line 9    Window Popups       (Scheme 9)
     Line 10   Browse              (Scheme 10)
     Line 11   Report              (Scheme 11)
     Line 12   Alert Popups        (Scheme 12)


                        User Defined Windows (Scheme 1)

     Color Pair     Windows Element
     1    Window text/Window background
     2    Window text/Application Workspace
     3    Window Frame/Window Background
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Window text/Window background
     10   Disabled text/Window background









                                     - Page 32 -


                                    System Setup


                         User Defined Menus (Scheme 2)

     Color Pair     Windows Element
     1    Menu text/Menu bar
     2    Window text/Menu bar
     3    Window Frame/Menu bar
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Menu text/Menu bar
     10   Disabled text/Menu bar


                              Menu Bar (Scheme 3)

     Color Pair     Windows Element
     1    Menu text/Menu bar
     2    Window text/Menu bar
     3    Window Frame/Menu bar
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Menu text/Menu bar
     10   Disabled text/Menu bar


                             Menu Popups (Scheme 4)

     Color Pair     Windows Element
     1    Menu text/Menu bar
     2    Window text/Menu bar
     3    Window Frame/Menu bar
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Menu text/Menu bar
     10   Disabled text/Menu bar







                                     - Page 33 -


                                    System Setup


                               Dialogs (Scheme 5)

     Color Pair     Windows Element
     1    Window text/Window background
     2    Window text/Window background
     3    Window Frame/Window Background
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Window text/Window background
     10   Disabled text/Window background


                            Dialog Popups (Scheme 6)

     Color Pair     Windows Element
     1    Window text/Window background
     2    Window text/Window background
     3    Window Frame/Window Background
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Window text/Window background
     10   Disabled text/Window background


                                Alert (Scheme 7)

     Color Pair     Windows Element
     1    Window text/Window background
     2    Window text/Application Workspace
     3    Window Frame/Window Background
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Window text/Window background
     10   Disabled text/Window background







                                     - Page 34 -


                                    System Setup


                               Window (Scheme 8)

     Color Pair     Windows Element
     1    Window text/Window background
     2    Window text/Application Workspace
     3    Window Frame/Window Background
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Window text/Window background
     10   Disabled text/Window background


                            Window Popups (Scheme 9)

     Color Pair     Windows Element
     1    Menu text/Menu bar
     2    Window text/Menu bar
     3    Window Frame/Menu bar
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Menu text/Menu bar
     10   Disabled text/Menu bar


                               Browse (Scheme 10)

     Color Pair     Windows Element
     1    Window text/Window background
     2    Window text/Application Workspace
     3    Window Frame/Window Background
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Window text/Window background
     10   Disabled text/Window background







                                     - Page 35 -


                                    System Setup


                               Report (Scheme 11)

     Color Pair     Windows Element
     1    Window text/Window background
     2    Window text/Window background
     3    Window Frame/Window Background
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Window text/Window background
     10   Disabled text/Window background


                            Alert Popups (Scheme 12)

     Color Pair     Windows Element
     1    Window text/Window background
     2    Window text/Window background
     3    Window Frame/Window Background
     4    Active title bar text/Active title bar
     5    Inactive title bar text/Inactive title bar
     5    For Windows 3.0: Active title bar text/Inactive title bar
     6    Highlighted text/Highlight
     7    Highlighted text/Highlight
     8    No mapping
     9    Window text/Window background
     10   Disabled text/Window background


                                  Color Pairs

     A color pair consists of a foreground and background color
     combination.  Foxpro uses eight basic colors: red, green, blue, cyan,
     magenta, yellow, white and black.  Each of these colors have two
     intensity levels: low intensity (dark) and high intensity (bright).
     Foxpro has two methods to represent color pairs: character code and
     RGB function.


                              Character Code Color

     Foxpro uses character abbreviations (R, G, B, W, N) for color values.
     Each color can have an attribute to change the intensity level.  Color
     codes that contain the plus sign (+) denote a bright foreground.
     Similarly, color codes that contain the asterisk (*) denote a bright
     background.  The plus sign (+) and the asterisk (*) can be placed
     anywhere in the color pair.



                                     - Page 36 -


                                    System Setup


                             Character Code Example

     Here is the character color code for red on dark gray (high intensity
     black):

     R+/N

     This is the same as any of the following:

     +R/N
     R/N+
     R/+N

     It is important to remember that both signs denote high intensity (or
     brightness).  The plus sign (+) denotes foreground intensity, and the
     asterisk (*) denotes background intensity no matter where they are
     located in the expression.

     The following is a table of the color codes that are available in
     Foxpro.


     Color     Code

     Black     N
     Blank     X
     Blue      B
     Brown     GR
     Cyan      BG
     Green     G
     Inverse   I
     Magenta   RB
     Red       R
     White     W
     Yellow    GR+
     Underline U

     Note:  An asterisk (*) can be used to denote blinking or bright
     (depending on your video hardware and the BLINK setting) for the
     background color.

     On monochrome monitors, only four colors are available: white (W),
     black (N), underlined (U) and inverse video (I).  The blank (X) color
     is useful for entering passwords.









                                     - Page 37 -


                                    System Setup


                                   RGB Color

     Colors can also be specified using the RGB color values.  These values
     range from 0 (lowest intensity or no color) to 255 (high intensity or
     bright color).  Each foreground and background require three values,
     one for red, one for green, and one for blue.  A color pair,
     therefore, requires six values, three for the foreground and three for
     the background.


                                  RGB Example

     Here is the RGB color code for red on dark gray (high intensity
     black):

     RGB(255,0,0,128,128,128)

     The first three values in the RGB expression above set the foreground
     color to red and the second three values set the background color to
     dark gray.

     The following is a table of the colors that are available in Foxpro,
     including the character codes and the corresponding RGB codes.

     Color          RGB                 Foreground     Background
     White          255,255,255         W+             W*
     Black          0,0,0               N              N
     Gray           192,192,192         W              W
     Dark Gray      128,128,128         N+             N*
     Red            255,0,0             R+             R*
     Dark Red       128,0,0             R              R
     Yellow         255,255,0           GR+            GR*
     Dark Yellow    128,128,0           GR             GR
     Green          0,255,0             G+             G*
     Dark Green     0,128,0             G              G
     Cyan           0,255,255           BG+            BG*
     Dark Cyan      0,128,128           BG             BG
     Blue           0,0,255             B+             B*
     Dark Blue      0,0,128             B              B
     Magenta        255,0,255           RB+            RB*
     Dark Magenta   128,0,128           RB             RB
     Blank          N/A                 X              X

     When you are using custom colors, the following rules apply for
     converting RGB values into character codes:

     When ALL of the three color values (R, G or B) are below 32, the
     character code is N.

     When ALL of the three color values (R, G or B) are between 32 and 64,
     the character code is N+.


                                     - Page 38 -


                                    System Setup


     When ALL of the three color values (R, G or B) are between 65 and 191,
     the character code is W.

     When ANY of the three color values (R, G or B) are above 191 the
     character code is high intensity (+ or *).

     Examples

     R    G    B    Character
     100  80   175  W
     100  200  175  W+/*
     33   56   45   N+/*
     33   56   175  B
     33   56   245  B+/*
     100  100  3    GR


                                Color Pair List

     A color pair list creates a color scheme.  This scheme which consists
     of one to ten color pairs separated by commas.  For example, in Foxpro
     for MS-DOS:

     W+/B, W+/BG, GR+/B, GR+/B, R+/B, W+/GR, GR+/RB, N+/N, GR+/B, R+/B

     A color pair list for a monochrome monitor might look like this:

     W/N, N+/W, W+/N, W+/N, W/N, U+/N, W+/N, -, W+/N, W/N

     Color pair lists for monochrome monitors may have a dash (-) in the
     eighth color pair location to indicate that a shadow isn't present.
     In Foxpro for Windows, a color pair list looks like this:

     RGB(0,255,0,255,0,0), RGB(127,255,0,0,0,0), ...

     Experiment with different color sets.  Note that the top of the screen
     may not change color until you exit and reenter the application.  Be
     warned, however.  The color set becomes permanent until the next time
     you select a different color.


                             Problems & Suggestions


     Upon pressing [4], you will be presented with a memo window.  Type any
     message you wish to leave the application programmer.  Press [F10] to
     complete the message, or [Esc] to abort.  Your message will be placed
     in the Foxpro error file (FOXERR.DBF).

     If you have already created messages, you may wish to modify them.  A
     browse, indicating the date and time of each message, will be
     displayed.  Select the desired message record.  Then, press [Ctrl]-
     [Pgdn] to expand the message window.
                                     - Page 39 -


                                    System Setup




                                  All About...


     Option '5', of the system menu, will display status information about
     this application.  What version of Foxpro is running, about much
     memory is available, and the different kinds of application modes
     (Multi-user, debug, system administration).  This option will also
     tell you how the various data paths are defined.


                                Edit File Lists



     If you are a system administrator, you can press '6' at the system
     menu.  You will be presented with a browse list of all valid files.
     Any file not defined in this list, is ignored by the VCM system.


                               Included File List


     This browse list contains only one column.  This column defines the
     valid VCM file names.  Wildcarding is permitted in this column.

     You can press [PgUp] or [PgDn] to browse the list, [Ctrl]-[N] to add
     an item to the list, or [Ctrl]-[T] to delete an item from the list.
     You can press [F10] to save, or [Esc] to abort.  Press [F10] to
     continue.

                               Excluded File List


     The next setup screen is also a browse list.  This list defines files
     to be excluded from the VCM system.  As with the included list,
     wildcarding is permitted.  Example:  Your included list could have had
     an entry to for "SYS*.DBF" files.  From the excluded list, you can
     narrow the include list by excluding "SYSD*.DBF" files.


                                Version Control


     The excluded browse list has two columns.  The second column defines
     the file extension for version control.  Unlike the first column,
     wildcarding is not permitted.

     I use a program called dVERSION.  dVERSION takes conditional source
     code and translates it into executable code.  Conditional code is
     usually stored in a sub-directory from executable code.

                                     - Page 40 -


                                    System Setup


     Example:  A program called "DP.VER" may contain conditional (modified)
     code.  dVERSION would translate "DP.VER" into "DP.PRG", an executable
     program.  "DP.VER" would be stored in "\DP\VER\".  "DP.PRG" would be
     stored in "\DP\".

     If you look at the default exclude browse list, you will see a line
     [*.PRG] [VER].  When the VCM System finds a program, such as "DP.PRG",
     it checks any sub-directories for a file called "DP.VER".  Only if
     "DP.VER" is found will the VCM system exclude the file "DP.PRG".
     Otherwise, "DP.PRG" remains included.  In this way, the VCM System
     doesn't have to send duplicate and unnecessary files.  Press [F10] to
     continue.

     If you don't want to use version control, simply leave the version
     control column empty.  If you do use version control, remember to also
     define your version control files as part of the regular include list.
     Otherwise, the VCM system will ignore them.

     Add or delete entries, if you wish.  Oh, you will not be able to
     delete the [*.??$] or [*.DIF] entries.  These files should never be
     transferred between host and remote sites.  The [*.??$] entry is for
     VCM backup files (see option B of the utility menu).  The [*.DIF]
     entry is for file comparison (see options 4 & 5 of the utility menu).

     When finished, press [F10].  You will be returned to the system menu.



                              Display/Print Manual



     Option 'M', of the system menu, will display the user manual.  You may
     use [PgUp] or [PgDn] to view various pages.  You may print the entire
     user manual by pressing [Alt]-[P].  Press [Esc] to return to the
     system setup menu.


                                      Quit


     Before leaving the system setup menu, a reminder.  Record filters
     remain in effect only for the duration of the application.  Color sets
     and printer control codes, on the other hand, are permanent.  When you
     have experimented enough, press [Q] at the system setup menu to return
     to the main menu.







                                     - Page 41 -


                                      Utilities


     Option 'U' of the main menu provides the miscellaneous options needed
     to maintain the VCM system.  Upon pressing [U] at the main menu, you
     should see the following:



        Version Control & Maintenance, Version 04.00.00
                     (c) 1992 Dennis Allen, All rights reserved

     -------------------  U T I L I T Y    M E N U ---------------------

                         1 _ Create new VCMPATH file set
                         2 - Create new VCM file set
                         3 - RollBack   VCM file set
                         4 _ Create new DIF files, Host to Remote
                         5 _ Create new DIF files, Host to Backup

                         A - Rebuild indices
                         B - Initialize Databases
                         C - Purge Backup.$$$ files

                         Q - Quit this Menu


                                Your selection:



     Option '1' will create a new set of file directories.  Option '2' will
     create a new set of VCM file records, without actually creating a new
     ZIP file.  Option '3' allows you to rollback what was done in option
     '2'.

     Option `4' will let you compare host files with remote files.  Option
     `5' will let you compare actual files to backup files.

     Option 'A' reconstructs all system indices in the event of a crash or
     other strange system behavior.  Option 'A' also removes deleted
     records, thereby reclaiming disk space.

     Option 'B' will allow you to remove the current user from any or all
     database files in the VCM System.  Option 'C' will allow you to remove
     VCM System backup files.  Option 'Q' will return you to the main menu.

     Note:  Option '1' is only available on the host.  Options '1', 'B',
     and 'C' are only available to the system administrator.  See
     configuration manual.






                                     - Page 42 -


                                      Utilities


                          Create new VCM Path File set


     When you create a new master set, a set of file directories are
     assigned.  Option '1' allows you to either assign a new set of file
     directories.

     Upon pressing [1], at the utility menu, you will be prompted for the
     root directory.  Select the desired directory and press [Ctrl]-
     [Enter].  You will be prompted whether to replace any existing master
     set.  Answering 'yes' will remove the existing directory list.  The
     specified directory, and all sub-directories (with any file defined in
     the included file list), will then be assigned.  You will be returned
     to the utility menu.


                            Create new VCM File set


     When you create a ZIP file from the main menu, either on the host or
     on the remote, a new set of records are created in VCM.DBF.  Any
     changes in VCM.DBF are recorded in VCMHIST.DBF.  Option '2' of the
     utility menu does the very same procedure.  Actually, it IS the same
     procedure.  However, no ZIP file is created.


                             Rollback VCM File set


     Let's say, for example, you created a REMOTE.ZIP and tried to send it
     to the host.  In the process your computer locks up and trashed the
     REMOTE.ZIP.  In such an event, use option '3' of the utility menu.

     Option '3' simply moves the records, found in VCMHIST.DBF, to VCM.DBF.
     In effect, this option returns the state of your VCM System to where
     it was before you sent the ZIP file.


                      Create new DIF Files, host to remote


     This utility will let you perform file comparison.  At the utility
     menu, press [4]. You will be prompted whether to update the VCM.DBF
     file (option 2 of the utility menu).  Normally, you press "Y".  You
     will be given the VCM.DBF option grid.  Press [F10] to complete the
     screen.  Press [C] to continue.

     The host and remote systems will now be checked.  If two associated
     files don't match (date, time, size), this utility will perform a file
     compare using the DOS utility FC.EXE.  For example, we could run FC to
     compare the host file "C:\VCM\VCM.PRG" to the remote file
     "C:\TMP\VCM.PRG".  The resulting output file ("C:\VCM\VCM.DIF" if we
     are host mode, "C:\TMP\VCM.DIF" if we are remote) will be created.
                                     - Page 43 -


                                      Utilities



     If we are comparing Foxpro *.DBF or *.FRX files, this utility will
     create temporary comma delimited *.TMP text files.  FC.EXE will then
     compare these TMP files, generating the DIF output files.

     Note.  The default file extension for FC.EXE output is "DIF".  If you
     wish to change this default, refer the configuration manual.


                      Create new DIF Files, host to backup


     Instead of comparing host files to remote files, option 5 of the
     utility menu will compare the current host (or remote) files listed in
     VCM.DBF, to the corresponding backup files.  Backup files the same as
     seen when trying to synchronize host and remote sites.  For example,
     the backup file of JOBPRA.PRG would be JOBPRA.PR$.

     Option 5, of the utility menu, provides the same prompts as option 4.
     For example, JOBPRA.PRG will be compared to JOBPRA.PR$, creating the
     output file JOBPRA.DIF.


                               Rebuilding Indices


     Option 'A' of the utility menu will reconstruct all system indices in
     the event of a crash or other strange system behavior.  You will be
     prompted whether to continue.  Upon pressing [Y], all indices will be
     rebuilt.  Option 'A' also removes deleted records, thereby reclaiming
     disk space.  You will then be returned to the utility menu.

     Note:  If you have the ability to recall deleted records, option 'A'
     will NOT remove deleted records.

                             Initializing Databases


     Option 'B' of the utility menu will allow you to "remove" the current
     user from any or all database files in the VCM System.  You probably
     will want to use this option after completing the sample entries and
     exercises in this manual, so you can begin fresh with "real" data.

     Upon press [B] at the utility menu, you will be prompted whether to
     reset each database file, one at a time.  You will then be returned to
     the utility menu.







                                     - Page 44 -


                                      Utilities


                             Purge Backup.$$$ files


     Whenever source code is received, the VCM System will make backup
     copies of existing files.  Example:  The VCM System would create
     "DP.PR$" as a backup of "DP.PRG".

     Option 'C', of the utility menu, simply deletes backup files.  Any
     file, with a file extension "$", are removed from any directory
     assigned.

     Well, that's it for the utility menu.  When you have experimented
     enough, press [Q] at the utility menu to return to the main menu.








































                                     - Page 45 -


                                     Quit to DOS


     Once you have returned to the main menu, press [Q] to return to the
     DOS ready.  It is VERY important that you do not leave the VCM System
     without returning to DOS.  NEVER turn off the machine while in the VCM
     System.  Doing so may result in file corruption and lots of headaches
     to us developers.

     Well, you have a sample user "TEMP" to experiment on the VCM system.
     The next step is to become a system administrator on the host system.
     As a system administrator, you will be able to remove the user "TEMP",
     or add new user(s).  If you have to, reinstall the VCM system on the
     host.

     This concludes the system overview.  If you wish to know more about
     any of the VCM editors in the VCM System, see Appendix A.  If you wish
     to know about the file layouts, refer to the configuration manual.  If
     you ever see the infamous error message "Ignore, Retry, Suspend, or
     Quit", see Appendix C.  If you wish to install the multi-user mode,
     see configuration manual.



































                                     - Page 46 -


                                     Appendix A


                           Appendix A/Generic Editor


     This section describes all characteristics, in detail, of the generic
     editor used in this type of Foxpro application.  While this editor may
     be customized for many applications, all share common functions.
     Thus, to learn one version is to know another version.

     This type of Foxpro application usually has an edit menu.  This menu
     allows the user to invoke one or more editors.  The following is an
     example of the edit menu used in the dMAIL4 System:



                        Mailing List, Version 03.05.00
                  (c) 1987 Dennis Allen, All rights reserved

     ----------------------  E D I T    M E N U ------------------------

                        1 - Create/Edit Mailing List
                        2 - Create/Edit State IDs

                        Q - Return to main menu


                                 Your selection:



     In this edit menu, the user has the option to use two editors.  Each
     editor allows the user to maintain separate, but related, databases in
     the dMAIL4 System.  While we really don't need to go any further, but
     it is good to know where most editors are invoked.

     Once a generic editor is invoked, its window will be displayed.  The
     window consists of a window title, field descriptions, and all fields
     of the database record that happens to be current.  A menu window is
     also displayed.  The menu window contains all the one-character
     options available to the user.  The following is a sample screen of
     the mailing list editor used in the dMAIL4 System:













                                     - Page 47 -


                                     Appendix A



                          Mailing List, Version 03.05.00
                      (c) 1987 Dennis Allen, All rights reserved

     --------------------------- Mailing List --------------------------
     User ID:
     First Name:                        Last:
                Billing                 Shipping
     Address 1 :
     Address 2 :
     City/State:
     Zip Code  :
     Sex:      Status:             Head of HouseHold:
     Home: (  )    -                    Birth:
     Work: (  )    -                    Wedding:
     Soc.Sec. #:   -  -                 Active Date:
          [ ] MS-DOS     +------------ Message Memo -------------+
          [ ] CP/M       |                                       |
          [ ] TRSDOS     |                                       |
                         +---------------------------------------+

            Toggle Index (Last Name)    Toggle Order (Ascending)
            Add    Browse Delete Find   Goto   Help  Recall  Update  Quit



     All editors have the same basic functions.  Before continuing, we will
     describe each function in detail.

                                  Add Function

     Pressing [A] will allow you to add a record to the current database.
     The cursor will be positioned on the first field in the record.  Now
     whether adding or updating a record, there only a few keystrokes you
     need to know.

     You can move the cursor from field to field using the arrow keys.  For
     instance, the Right arrow, the Down arrow, and the [Enter] key, moves
     the cursor forward one field at a time.  The left arrow and up arrow
     will move the cursor back one field.

     Note:  If you have a mouse, you also can move from field to field.
     Simply move the mouse cursor to the desired field and press the left
     mouse button.

     The [Home] key will move the cursor to the beginning of a field.  If
     the cursor is already there, [Home] will move the cursor to the first
     field in the screen.  The [End] key will move the cursor to the end of
     the field.  If the cursor is already there, [End] will move the cursor
     to the last field in the screen.



                                     - Page 48 -


                                     Appendix A


     If you need more information on any field, press [F1].  If there is
     help information, a help window will be displayed.  The help window
     will remain until you press either [Esc] or [F10].

     Pressing [Ctrl]-[Home] will repeat the last text that was displayed in
     the current field.  This function provides a convenient means of
     adding many records with similar field descriptions.

     Once you have entered your data, moving the cursor beyond the last
     field on the screen tells the editor to accept the record.  Pressing
     [F10] also will tell the editor to accept the record.  You would then
     be prompted to add another record.  The [Esc] key will abort the add
     function, returning the screen to its original condition.

                                Browse Function

     Pressing [B] will invoke the Foxpro browse function.  The browse
     function will display as many database records as will fit in one
     window.  You can use the left arrow, right arrow, [Tab], and [Shift]-
     [Tab] keys to move the cursor from field to field.  You can move from
     record to record with the up and down arrow keys.  You use the page
     up/down keys to display the next/previous window of records in the
     current database.

     If you have a mouse, you also can use the characters located on the
     right side of the window.  Place the mouse cursor on the up/down arrow
     characters and press the left button to move one record at a time.
     The diamond character show where you're located in relation to the
     rest of the database.  Place the mouse cursor on the diamond and press
     the left button.  Dragging the diamond will re-position you in the
     database.

     Mouse Note:  After you found the record you want, place the mouse
     cursor on the record and press the left button.  Otherwise, the first
     time you try to update a record will put you back to the last record
     displayed before using the mouse.

     If there are more fields than can be displayed in one window, pressing
     [TAB] will scroll to the next field.  Pressing [Shift]-[TAB] will
     scroll back one field.

     If you have a mouse, you also may use the characters located across
     the bottom of the window.  Place the mouse cursor on the left/right
     arrow characters and press the left button to move one field at a
     time.  The diamond character show where you're located in relation to
     the rest of the database.  Place the mouse cursor on the diamond and
     press the left button.  Dragging the diamond will re-position the
     fields displayed in the database.

     Mouse Note:  After you found the field you want, place the mouse
     cursor on the field and press the left button.  Otherwise, the first
     time you try to update a field will put you back to the last field
     displayed before using the mouse.
                                     - Page 49 -


                                     Appendix A



     In the browse function you may edit any field as desired.  Press
     [Ctrl]-[N] to add a record from the browse.  Press [Ctrl]-[T] to
     delete the current record from the browse.  When finished, press
     [F10] to return to the edit menu.  Pressing [Esc] also will return you
     to the edit menu, but it will abort any change to the current record.

     Note:  The JKEY incremental search has recently been added to the
     browse command.  When performing a browse, press [Ctrl]-[J] to
     activate JKEY.  A search will begin on the current index.  Each new
     keystroke will be added to the search string and the record, closest
     matching to the current string, will be displayed.  You may press
     [BackSpace] to revise the search string, or press [Ctrl]-[Y] to clear
     it.  To abort JKEY, simply press [Ctrl]-[J] once again (or [Esc] to
     abort the browse).

                                Delete Function

     Pressing [D] will allow you to delete the currently displayed record.
     You will be prompted whether you are sure.  Pressing [Y] deletes the
     record from the database.

                                 Find Function

     Pressing [F] will invoke the find function.  This option is only
     available if a database is indexed.

     If invoked, you would type the key of the desired record, and press
     [Enter].  If found, the record would be displayed.  You could then
     delete it, or update it.


     Note:  The key doesn't have to be a complete description.  For
     incomplete keys, the find function will try to find the record with
     the closet matching key.

     Recently, wild-carding has been introduced into the [F]ind function.
     For example, suppose we have a customer file.  It has an index by last
     name.  When the find function prompts us, we could type:

          Last Name:  ..ll..

     In this example, we are searching for a customer whose last name
     contain a "ll".  In another example:

          Last Name:  ..en

     We are searching for a customer whose last name ends with "en".  In
     one more example:

          Last Name:  al..

     We are searching for a customer whose last name begins with "al".
                                     - Page 50 -


                                     Appendix A



     Here's where wild-carding get interesting.  Let's use the first
     example.  Say we find a customer whose last name contains a "ll".  If
     we use the [G]oto function, we get an extra option.  This option,
     called [C]ontinue, will allow us to find the next customer whose last
     name contains a "ll".

     The continue option will remain in effect until you perform another
     find.  It will search for the next wild-card occurrence no matter
     where you are in the database.  In that sense, think of wild-carding
     as an implicit record filter.

     Oh, a new feature has been added to wild-carding:  The triple period
     "...".  Like the double period "..", the triple period denotes wild-
     carding.  Using the triple, however, will also disable the current
     index during the search.

     You see, wild-card searches are a LOT faster when done on an unordered
     database.  So if you are looking for just one record or two records,
     don't care about viewing order, and are using a huge database, the
     triple period might save you valuable time.

                                 Goto Function

     Pressing [G] will create a pop-up menu.  This popup menu allows the
     user to display different records in the current database.  Press [F]
     for the first record in the database.  Press [L] for the last record.
     Press [N] for the next record.  Press [P] for the previous record.
     The goto window remains active until you press [Esc] or [Q] to quit.

     If the current database is indexed, order is defined by the toggle
     order function.  For example, if the current record is customer 5,
     pressing [N] will display customer 6.  If the index order is
     descending, however, pressing [N] will display customer 4.  See toggle
     index order.

     A new option, [W] for window, has been added.  Pressing [W] activates
     the goto window.  The user may then move the goto window to any
     location on the screen.  That location remains in effect for the
     duration of the editor.

     To move the window, press [Ctrl]-[F7].  The goto window border will
     flash.  Press any cursor key to move the window.  Press [Ctrl]-[F7] to
     stop the window from flashing.  Then press [Esc] to resume the normal
     goto prompts.

     Note:  You also may use a mouse to move the goto window.  Press [W].
     Place the mouse cursor on the border of the goto window.  Press the
     left button.  Drag the mouse cursor (and window) to the desired
     location.  Then, press the right button to resume the goto prompts.



                                     - Page 51 -


                                     Appendix A


                                 Help Function

     Pressing [H] will display a summary of commands used in the edit menu
     as in the following screen.  Pressing any key after that returns you
     to the edit menu.


         Command prompt

         [T]oggle Index -  Change Index used by [F]ind command
         Toggle [O]rder -  Current Index in Ascending/Descending Order

         [A]dd        -  Add a record to the current database
         [B]rowse     -  List all records a page at a time
         [D]elete     -  Delete the currently displayed record
         [F]ind       -  Search database for record with specified key
         [G]oto       -  Display the First, Last, Next, or Previous record
         [H]elp       -  Display help information
         [R]ecall     -  Recall Deleted Records
         [U]pdate     -  Update the currently displayed record
         [Q]uit       -  Return to calling program

         Common full screen keystrokes

         [ESC]        -  Abort operation, return to prompt/menu
         [HOME]       -  move cursor to beginning field
         [END]        -  move cursor to ending field
         [CTRL][HOME] -  repeat last input field completed
         [CTRL][END]  -  Complete operation, return to prompt/menu
         [F1]         -  Display Help text
         [F10]        -  Complete operation, return to prompt/menu






















                                     - Page 52 -


                                     Appendix A



                                Recall Function

     When available, pressing [R] allows you to recall a deleted record.
     You will be presented with a browse window of all deleted records.
     Simply locate the record to be recalled and press [Enter].

     To enable this feature, see your configuration manual.


                             Toggle Index Function

     For databases with multiple indices, the toggle option will be
     displayed.  The toggle option allows the user to change what index
     will be used with the [F]ind option.  The current index is displayed
     in parenthesis.

                             Toggle Order Function

     This option toggles the order of the current index.  The current order
     is displayed in parenthesis.

     For example, if the current order is ascending, pressing [O] will
     toggle the order to descending.  If the current index is by last name,
     then 'ALPHA' will come after 'BETA'  Pressing [O] again will change
     the current index back to ascending.

                                Update Function

     Pressing [U] allows you to update the currently displayed record.
     Like the add function, moving the cursor past the last field will
     complete the updating.  Pressing [Esc] will abort any update.

                                 Quit Function

     Finally, pressing [Q] will quit the editor.  You will be returned to
     the menu that invoked the editor.
















                                     - Page 53 -


                                    Appendix A-1


                        Appendix A-1/Foxpro System Menu


     If you ever been on an input field, you may have noticed that pressing
     [Alt] ([Ctrl]+[Opt] on the Mac, [F10] in Unix) displays a menu at the
     very top of the screen.  This is called the Foxpro system menu, or
     sysmenu for short.  The system menu displayed is a customized version
     of the Foxpro sysmenu.  It contains a variety of functions and is
     available to all users.  The following describes only a few features
     available through the sysmenu.  For more information, see the Foxpro
     users manual.


                                  Sysmenu edit


     The sysmenu edit popup is very powerful.  It gives any input field a
     variety of edit functions.  For example, highlighting a section of
     text ([Shift] and cursor key) and pressing [Del] will delete this
     text.  But [Ctrl]-[C] would have copied this text into the clipboard.
     You would then use [Ctrl]-[V] to paste this text.

     Note:  The sysmenu edit popup provides a [Ctrl]-[U] option to undo a
     deletion, copy, cut, or paste.

     Another example:  Suppose you are editing a memo field.  The sysmenu
     edit popup provides a [Ctrl]-[F] option to find specified text.  This
     popup also provides a [Ctrl]-[G] option to repeat the last find.

     There are other functions in the sysmenu edit popup.  See the Foxpro
     users manual for details.


                               Foxpro Calculator


     Simply enter a numeric value on any input field.  Press [Alt]-[F4] to
     activate the Foxpro calculator.  The Foxpro calculator will display
     your numeric value.

     When you have a new calculated value, press [Ctrl]-[F4] to deactivate
     the calculator.  Your new numeric value will be placed into the
     current input field.

     Note:  If you just want the calculator, press [F4].  To close, mouse
     click on the upper left button of the calculator and select [Close].







                                     - Page 54 -


                                    Appendix A-1


                                Foxpro Calendar


     Simply enter a date on any input field.  Press [Alt]-[F5] to invoke
     the Foxpro calendar.  The Foxpro calendar will display the year,
     month, and day of the specified date.

     Select any desired date.  When you have a new date, press [Ctrl]-[F5]
     will deactivate the calendar.  Your new date will be placed into the
     current input field.

     Note:  If you just want the calendar, press [F5].  To close, mouse
     click on the upper left button of the calendar and select [Close].


                                Foxpro DOS Shell


     In Foxpro for DOS, the system pulldown menu provides a DOS shell.  If
     you are a system administrator, pressing [Alt]-[S] [O] brings up the
     DOS command window.  Type any desired DOS command.  Type 'EXIT' and
     press [Enter] to leave the DOS shell.


                                  Print Setup


     You can customize printer output with 'Print Setup' (sometimes called
     'Page Setup').  For example, before creating a report you can call up
     the page setup dialog box to change your printer output from portrait
     to landscape.


                                   Print Mode


     In Foxpro for windows, you can print the contents of the current
     window using the 'Print' option of the 'File' popup in sysmenu.  The
     'Print' option is equivalent to printing a report in non-draft mode.
     See system setup, printer codes.

     Note:  'Print' is not currently available in the Foxpro for windows
     runtime unit.


                                 Printer Eject


     Press [F7] for a page eject.  You will be prompted for a form feed.
     If you select [Y], a form feed will be sent to the current printer
     device.  See System Setup, printer codes.  This option is very useful
     for people with Laser Printers.

                                     - Page 55 -


                                    Appendix A-1



                                  User Manual


     This sysmenu option will display the user manual.  Equivalent to
     option 'M', of the application's system menu.  You may use [PgUp] or
     [PgDn] to view various pages.  You may use [Ctrl]-[F] to search for
     text.  You may print the entire manual by pressing [Alt]-[P].  Press
     [Esc] to return to the application.


                              Configuration Manual


     If you are a system administrator, this sysmenu option will display
     the configuration manual.  You may use [PgUp] or [PgDn] to view
     various pages.  You may use [Ctrl]-[F] to search for text.  You may
     print the entire manual by pressing [Alt]-[P].  Press [Esc] to return
     to the application.


                                   Video Mode


     Press [Alt]-[V] for the video mode.  In Foxpro for DOS, a VGA screen
     will toggle between 25 and 43 line modes.  All subsequent windows will
     conform to the specified mode.  Very useful in displaying reports.

     In Foxpro for windows, [Alt]-[V] will display a font selector.  All
     sub-windows, to the current window, will conform to the specified
     font.  If you change at the main menu window, the font becomes
     permanent to the user.





















                                     - Page 56 -


                                     Appendix B


                      Appendix B/Backup/Restore Data Files


     To insure the integrity of its data files, any major database should
     have a standardized backup procedure.  Data files should be
     periodically copied to a media, other than where they currently
     reside.  There is NO excuse for not developing a proper backup
     procedure.

     As a supplement, however, this application includes its own backup
     procedure.  To back up data, you must be in the application directory.
     At the DOS prompt type:

               BACK

     and press [Enter].  This command will copy all data files into a
     backup directory ('.\BAK').  In case of power failure, these backup
     files could be used to recover previous work.

     Restoring these backup files is simple.  To restore data, you must be
     in the application directory.  At the DOS prompt type:

               UNBACK

     and press [Enter].  This command restores all data up to the point you
     last invoked BACK.

     Note:  If you decide to store data files in a separate directory (See
     configuration manual), make sure the data directory has a '.\BAK'
     backup directory.  You would then execute BACK and UNBACK from your
     data directory.  For convenience, you might consider coping BACK.BAT
     and UNBACK.BAT into your data directory.

     Warning:  If you ever run into a problem with this application, NEVER
     invoke the "BACK" command without first resolving the problem.  If a
     data file is corrupt, using "BACK" would only copy this corrupted file
     over a good backup file.
















                                     - Page 57 -


                                     Appendix C


                           Appendix C/Error Handling


     In the course of normal events, you shouldn't see any error messages.
     But events can happen to cause an error message.  The most common
     events are:  Verification, disk space used up, printer not ready,
     multi-user, or syntax error.

                                  Verification

     When you start your application, all databases files are inspected.
     If a database file doesn't exist, it is created.  If a database file
     is missing a field, it is added.  If a field is not the correct
     length, it is lengthened.  If a structural index tag is missing or not
     in the correct order, the entire CDX file is rebuilt.

     Of course, the verification could fail.  There are many reasons for
     verification to fail.  On a network, someone could be using the
     database file(s) you're trying to update.  Or, you might not have the
     access permission to create/update database file(s) in your data
     directory.  Whatever the reason, remember that verification fails only
     when a database file needed to be changed, but could not be updated.
     In such an event, consult your system administrator.

                                Bad Record Count

     If a database file has a bad record count, the verification process
     will try to repair it.  If the database file could not be repaired,
     however, a new (and empty) database file is created.  The corrupted
     DBF file is renamed as a BAK file.  Any associated FPT file will be
     renamed as a TBK file.

     Please keep this feature in mind when you invoke your own database
     repair utility.  An empty database file doesn't necessarily mean you
     lost your data.  Your corrupted data probably resides in BAK and TBK
     files.  But, depending on the damage, you may need the header of the
     empty database file to repair your corrupted data.

     Before any repairs, I suggest creating a floppy disk or tape backup of
     your BAK and TBK files.  In fact, it might be best just to backup all
     the files found in your data directory.

     Once repairs are complete, simply rename the repaired BAK file as the
     DBF file.  Rename any associated TBK file as a FPT file.  Oh, and
     remove the associated CDX file (will be rebuilt the next time you
     start the application).







                                     - Page 58 -


                                     Appendix C


                           Invalid/missing memo file

     If a database file has a bad memo file, the verification process will
     take several steps to try to repair it.

     First, the original DBF file is copied to a file with a DB2 extension.
     The original FPT file will be copied to a file with a FP2 extension.
     Please keep this backup feature in mind if you invoke your own
     database repair utility.

     Next, the verification process will try to repair the FPT file header.
     If the FPT file is missing, the process will create one.  This action
     should allow the DBF file to be once again opened.

     Now a corrupted memo file may appear normal, except when you try to
     PACK a couple of times.  So as a final step, the verification process
     will create a new DBF file and will append data from the original DBF
     file.  While these steps are not foolproof, they should allow you to
     once again PACK your DBF file.

     Programmer's note: A corrupted memo file can lay dormant for years,
     until someone tries to run PACK (option A of utility menu).  My
     standard error handler now checks for error() = 41 from a PACK.  The
     error handler first allows the user to create backup files, with DB1
     and FP1 extensions.  The user is then allowed to blank out the first
     512 bytes of the memo file.  In this way, the verification process
     will be able to detect and perhaps repair the corruption.

                             Visual Foxpro DBF File

     If a database file was converted to the Visual Foxpro format, the
     Foxpro 2.6 runtime will not be able to open the file and verification
     will fail.  In such an event, run this application under the Visual
     Foxpro runtime.  Verification will then be able to open the database
     file and convert it to the Foxpro 2.6 format.


















                                     - Page 59 -


                                     Appendix C



                                   Disk Space


     If ever you see data records that look like garbage, you may have bad
     sectors on your hard disk.  Ask your system administrator to take a
     look at it.  The usual procedure is to back up all programs/data, and
     reformat the hard disk.  Any bad sectors found should be locked out
     and should no longer cause a problem.

     Bad data can result from lack of free space on the hard drive.  While
     you cannot start this application without a minimum amount of free
     space, it's always possible you might have used a routine that filled
     up your hard drive.  If this be the case, exit the application.  If
     you cannot get back into the application, due to lack of free space,
     have your system administrator remove all unused temporary files.  If
     you still cannot get back in, you might have to restore backup files.


                               Printer not Ready


     If you're printing a report and the printer is not on, you will get a
     message:

          Printer not ready.
          Press anything to retry, 'Q' to quit"

     Simply turn on your printer, and press any key to retry.  Your report
     should start to print.  Pressing "Q" would have aborted the report and
     returned you to the main menu.

     If you retry and still get "Printer not ready", you may have to
     perform the following DOS command:

          MODE LPT1,,P

     This command tells DOS to perform an infinite number of retries on the
     print device "LPT1".  Depending on you machine, you may also have to
     increase the Foxpro printer time-out.  See configuration manual.













                                     - Page 60 -


                                     Appendix C



                               Multi-User Errors


     If you running this application under the multi-user mode, you may be
     presented with two different type of error messages.  Both types have
     to do with file locking.

     For example, you may be updating a database record.  In the meantime,
     however, somebody else may have already updated that record.  When
     your update is complete, you will receive the message:

          Current record has been altered

     In that case, review the updated record and try the update again.

     Another kind of message occurs while you are performing some kind of
     transaction processing.  If you need a record that somebody else has
     locked out, you will receive the message:

          Waiting for access, press [ESC] to abort

     In this case, just wait.  Most of the time, the record you need will
     be quickly released.


                                  Syntax Error


     The last kind of problem is a syntax error.  You shouldn't ever see
     one.  In case you do, however, you will be prompted:

          [I]gnore, [R]etry, [S]uspend, or [Q]uit to Main Menu.

     Unless you're a system administrator, your best bet is to press [Q] to
     Quit to Main menu.  Pressing [Q] will automatically log the error into
     the Foxpro error file (FOXERR.DBF).

     Don't forget to tell your system administrator about the error.  As
     the author, I'll want a copy of your FOXERR.* files to determine the
     type of error that occurred and to possibly correct it.












                                     - Page 61 -


                                      GLOSSARY


     ANSI  -  American National Standards Institute.  A standard for both
          screen output and keyboard input.

     Arrow Keys  -  Equivalent to cursor keys.  Those keys on the keyboard
          labeled with arrows.

     ASCII  -  American Standard Code for Information Interchange.  A
          standard 7 bit code used to represent data.

     Batch File  -  A file containing multiple DOS commands.  These
          commands are executed by DOS, one at a time, as if typed by the
          user.

     Byte  -  A unit of information.  In text form, equivalent to an ASCII
          character.

     Code  -  Program code.  Another way of saying program instructions.

     Compiler  -  A program that converts program code from one form to
          another, usually more primitive, form.  The converted code is
          then ready for execution.

     CONFIG.FP  -  The Foxpro for DOS configuration file.  This file tells
          Foxpro where is find the resource file.  In Foxpro for Windows,
          it would called CONFIG.FPW.  In Foxpro for Macintosh, it would be
          called CONFIG.FPM.

     Cursor  -  A flashing character on the screen.  It indicates where
          typed text will be next placed.

     Cursor Keys  -  Equivalent to arrow keys.  Those keys on the keyboard
          labeled with arrows.

     Data Dictionary  -  A database file that defines the input/output to
          database files in an application.

     dBASE  -  Popular database management language.  The software package
          dBASE III+ is an interpreter for dBASE code.

     dVERSION  -  A program that translates dBASE code, conditional upon
          specified parameters, into executable dBASE code.

     Disk  -  A unit where information is stored.  There are two major
          types: hard disk, and floppy disk.

     Disk Error  -  An error occurring when a program is unable to read or
          write properly to a disk.

     Diskspace  -  A unit of how much room is available on a drive.  It is
          usually measured in bytes.

     DOS  -  Disk Operating System.

                                     - Page 62 -


                                      GLOSSARY


     EMS  -  Refers to expanded memory.  Most 80286 computers have expanded
          memory.  80386 computers have extended memory.  There are,
          however, 80386 software drivers (QEMM for example), that can
          offer either extended or expanded memory.

     Extended  -  Extended memory.  80386 (or better) computers have
          extended memory.  The extended version of Foxpro needs at least
          three megabytes of extended memory.  The standard version of
          Foxpro requires expanded memory.

     Filespec  -  any DOS filename.ext including catalog names, passwords,
          etc.

     Floppy Disk  -  A self contained unit where information is stored.
          Depending on the type, floppy disks are easily transportable.
          Sometimes called a diskette.

     Foxbase  -   A dBASE III plus compatible language.

     Foxpro  -   A dBASE IV compatible language.

     FOXERR.DBF  -  The Foxpro error file.  Every major error event is
          recorded in this file.

     FOXUSER.DBF  -  The Foxpro resource file.  This file stores all the
          attributes of the user.

     Hard Disk  -  A self contained unit where information is stored.
          Usually not removable.

     HELP  -  A facility that provides on-line assistance in the use of a
          given program.

     Highlight  -  A form of a cursor, where an entire field is considered
          the cursor.

     Interpreter  -  A program that executes language code.  Whereas a
          compiler translates program code to executable code, an
          interpreter translates a single line of program code before
          executing it.

     Kilobyte  -  One kilobyte of memory equals 1,024 bytes.

     Megabyte  -  One megabyte of memory equals 1,024,000 bytes.

     Multi-user  -  When more one than one person is capable of
          accessing/updating the same database at the same time.

     MS-DOS  -  Microsoft Disk Operating System.

     PKZIP.EXE  -  PKWare's data compression utility.  Creates ZIP files.
          License for use within VCM.

                                     - Page 63 -


                                      GLOSSARY


     PKUNZIP.EXE  -  PKWare's data expansion utility.  Expands ZIP files.
          License for use within VCM.

     Sideways  -  A DOS Utility that will print text up and down instead of
          across the paper.

     Source Code  -  What a translator/compiler takes in as input.

     Syntax  -  The rules for the arrangement of statements in a
          programming language











































                                     - Page 64 -


                                        Index



     [Alt]-[F4], 54
     [Alt]-[F5], 55
     [Alt]-[V], 56
     [Ctrl]-[F4], 54
     [Ctrl]-[F5], 55
     [Ctrl]-[Home], 49
     [Ctrl]-[J], 50
     [Ctrl]-[N], 50
     [Ctrl]-[T], 50
     [Ctrl]-[Y], 50
     [End], 48
     [Esc], 49
     [F1], 49
     [F10], 50
     [F4], 54
     [F5], 55
     [F7], 55
     [Home], 48
     [Shift]-[TAB], 49
     [TAB], 49
     Add Function, 12, 48
     All About..., 40
     ANSI, 62
     Arrow Keys, 62
     ASCII, 62
     BACK, 57
     backup, 8, 59
     backup files, 19, 25, 41, 44, 45
     Backup/Restore Data Files, 57
     Bad Record Count, 58
     Batch File, 62
     Browse Function, 13, 49
     Byte, 62
     Change Color Set, 31
     Character Code Color, 36
     Check DIF files, 25
     Check Parameter Code, 23
     Check Translated Code, 23
     Client Overview, 8
     Code, 62
     Color Pair List, 39
     Color Pairs, 36
     Color Schemes, 32
     Compare VCM to Backup, 25
     Compare VCM to Remote, 24
     Compiler, 62
     CONFIG.FP, 62
     Configuration Manual, 56
     Create new DIF Files, host to backup, 44
     Create new DIF Files, host to remote, 43
     Create new VCM File set, 43
     Create new VCM Path File set, 43
                                     - Page 65 -


                                        Index


     Creating HOST.ZIP, 16
     Creating REMOTE.ZIP, 10
     cursor, 48
     Cursor, 62
     Cursor Keys, 62
     Customizing Color Sets, 32
     Data Dictionary, 62
     database of source code, 5
     dBASE, 62
     dBASE IV, 1
     DBF, 44
     Delete Function, 13, 50
     DIF, 25, 41, 44
     Disk, 62
     Disk Error, 62
     Disk Space, 60
     Diskspace, 62
     Display/Print Manual, 41
     DOS, 5, 62
     Draft mode, 30
     dVERSION, 40, 62
     Edit File Lists, 40
     editor, 5
     EMS, 63
     Error Handling, 58
     Excluded File List, 40
     expression builder, 5
     Expression Builder, 27
     extended, 1
     Extended, 63
     FC, 43
     file directory, 5
     file path, 5
     Filespec, 63
     filter, 26, 27
     Find Function, 13, 50
     Floppy Disk, 63
     font, 56
     Foxbase, 63
     FOXERR.DBF, 39, 61, 63
     Foxpro, 1, 5, 63
     Foxpro Calculator, 54
     Foxpro Calendar, 55
     Foxpro DOS Shell, 55
     Foxpro for DOS, 56
     Foxpro for windows, 56
     Foxpro runtime unit, 9
     Foxpro System Menu, 54
     FOXUSER.DBF, 31, 63
     FOXUSER2.DBF, 32
     FRX, 44
     Generic Editor, 47
     Goto Function, 13, 51
                                     - Page 66 -


                                        Index


     Hard Disk, 63
     HELP, 63
     Help Function, 13, 52
     Highlight, 63
     host, 8
     Host Start-up, 9
     HOST.ZIP, 8, 16
     Included File List, 40
     Initializing Databases, 44
     Interpreter, 63
     Invalid/missing memo file, 59
     JKEY, 50
     Kilobyte, 63
     Laser Printers, 55
     Macintosh, 7
     Megabyte, 63
     megabytes, 1
     memo, 39
     MODE, 60
     MS-DOS, 1, 63
     Multi-user, 29, 63
     Multi-User Errors, 61
     network, 29
     non-draft, 55
     non-draft mode, 30
     Notation Conventions, 7
     Number of Copies, 30
     Page Setup, 55
     PKUNZIP.EXE, 64
     PKZIP.EXE, 63
     Print Mode, 55
     Print Setup, 55
     Printer Codes, 29
     Printer Control Codes, 28
     Printer Device, 29
     Printer Eject, 55
     Printer Font, 30
     Printer Name, 28
     Printer not Ready, 60
     Printing VCM Edit List, 21
     Printing VCM History Edit List, 21
     Printing VCM Path Edit List, 22
     Problems & Suggestions, 39
     program files, 5
     Programmer Overview, 8
     Purge Backup.$$$ files, 45
     Quit, 19, 25, 41
     Quit Function, 14, 53
     Rebuilding Indices, 44
     Recall Function, 13, 53
     record filter, 5, 26, 27
     remote, 8
     Remote Start-up, 10
                                     - Page 67 -


                                        Index


     REMOTE.ZIP, 8, 10
     RGB Color, 38
     Rollback VCM File set, 43
     security clearance, 8
     Sideways, 64
     Sideways lines per page, 30
     source code, 5
     Source Code, 64
     Straight lines per page, 30
     Syntax, 64
     Syntax Error, 61
     sysmenu, 54
     Sysmenu edit, 54
     system administrator, 9, 18, 27, 28, 31, 46, 55, 56, 58, 60, 61
     Test Report, 31
     Toggle Index Function, 14, 53
     Toggle Order Function, 14, 53
     UNBACK, 57
     Update Function, 14, 53
     Updating a VCM Path Record, 14
     Updating VCM Paths, 11
     Upgrading from Previous Version, 6
     User Manual, 56
     VCM, 1, 5
     VCM.DBF, 11, 17, 24
     VCMHIST.DBF, 11, 17
     VCMPATH.DBF, 11, 17
     Verification, 58
     Version Control, 40
     Video Mode, 56
     Visual Foxpro, 59
     Visual Foxpro DBF File, 59
     wild-carding, 50
     window, 5
     ZIP Files, 17


















                                     - Page 68 -  